# Release version 10.0.20183.611 - 11/05/2018

## C1.UWP.RichTextBox

### Bug fixes:

- [RichTextBox][Regression] "System.NullReferenceException" is thrown when changing the ViewMode from Print to Draft at RunTime.(TFS-352236)
- [RichTextbox][Regression] Only one character can't be selected in C1RichTextBox. (TFS-352253)

# Release version 10.0.20183.609 - 10/20/2018

## C1.UWP.FlexChart

### Bug fixes

- Fixed exception that may happen when using auxiliary axes (TFS:347851).
- Fixed problem with incorrect clipping (TFS:348812).

## C1.UWP.RichTextBox

### Bug fixes:

- [RichTextBox]Images and horizontal lines are not selected/removed after select all content by pressing Ctrl+A and press Delete/Backspace key. (TFS-349110)
- [RichTextBox]Non editable element disappears when trying to select by mouse dragging and appear only after release from mouse dragging. (TFS-349143)
- [RichTextBox]Tabel cannot be deleted if table is added before and under the text or only table is added in the page. (TFS-349147)

# Release version 10.0.20183.608 - 10/18/2018

## C1.UWP.Excel

### Bug fixes

- C1Excel generates ArgumentOutOfRangeException on loading with file created in Colombian Spanish culture. (TFS:346224)

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect] Text Of Tag cannot be able to deleted and automatically replaced with other word in Tag when delete the text in Tag by using Backspace key in "Append/SuggestAppend" AutoCompleteMode. (TFS-323932)
- [C1TagEditor] tag can't be deleted by clicking cross button of that tag when InsertTag()method or controlName.Tags.Add() method is used under InitializedComponent() in C1TagEditor. (TFS-348611)

# Release version 10.0.20183.607 - 10/17/2018

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect] Focus cursor is moved to infornt of the text and last selected item is lost when pressing the "Spacebar" key in C1MultiSelect. (TFS-345582)
- [C1MultiSelect] NullReferenceException thrown when pressing 'Up' key after deleting some characters of item in text display mode using 'Backspace' key. (TFS-348023)

## C1.UWP.RichTextBox

### Bug fixes:

- [C1RichTextBox] Loading images in C1RichTextBox asynchronous. (TFS-347990)

# Release version 10.0.20183.606 - 10/16/2018

## C1.UWP.FlexChart

### Bug fixes

- Tooltips displayed correctly when complex binding string contains spaces (TFS:347548).
- FinancialChart's default tooltip content is now consistent with FlexChart (TFS:347591).
- Fixed exception when resizing chart with legend with scrollbar (TFS:347864).

# Release version 10.0.20183.605 - 10/12/2018

## C1.UWP.FlexChart

### Bug fixes

- Added support of animation when toggling legend items (TFS:345247).
- Binding fields with spaces parsed correctly now (TFS:346082).

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect] Incorrect behaviors are observed when setting AutocompleteMode to "Append". (TFS-323327)
- [C1MultiSelect] Incorrect behaviors are observed when setting AutoCompleteMode to SuggestAppend. (TFS-323621)
- [C1MultiSelect][C1CheckList] Same data items are not selected although checking ‘SelectAll’ checkbox when same value data items are binded in C1MultiSelect dropdown. (TFS-310780)
- [C1MultiSelect][Regression] Newly added items are not shown in C1listviewer when adding items from C1MultiSelect dropdown. (TFS-345883)

## C1.UWP.Maps

### Bug fixes:

- [Maps]"System.NullReferenceException" occurred in C1.WPF.Maps.4.dll when navigation to the "Analysis" tab of DashboardDemo.(TFS-347512)

# Release version 10.0.20183.604 - 10/06/2018

## C1.UWP.FlexChart

### Bug fixes

- Fixed exception during pie chart animation (TFS:345579).
- Fixed exception during legend rendering (TFS:344722).
- Fixed legend scrollbar visibilty issues (TFS:344782).
- Fixed incorrect legend toggling when legend has a scrollbar (TFS:344814).
- Fixed problem with showing axis grid lines during animation (TFS:345076).
- Add support of mouse wheel for legend scrolling (TFS:345292).
- Size of legend is limited to provide a space for plot (TFS:345544).

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] System.IndexOutOfRangeException occurred when deleting all text and press up key from keyboard. (TFS-345583)
- [C1MultiSelect][C1TagEditor] PlaceHolder Text is shown when click on DisplayArea that is set "IsEditable=False" after selecting items in Tag DisplayMode. (TFS-327017)
- [C1MultiSelect][C1TagEditor] Item text in DisplayArea are selected when click on DisplayArea even setting IsEditable=False (TFS-327027)
- [C1MultiSelect] Text Of Tag cannot be able to deleted and automatically replaced with other word in Tag when delete the text in Tag by using Backspace key in "Append/SuggestAppend" AutoCompleteMode. (TFS-323932)

## C1.UWP.Sparkline

### Bug fixes

- Sparkline binding get lost when it is used in CellTemplate of the C1FlexGrid control. (TFS-345284)

# Release version 10.0.20183.603 - 09/21/2018

## C1.UWP.Document

### Bug fixes:

- Text displaying incorrectly after export to PDF. (TFS:342881)

## C1.UWP.FlexChart

### Bug fixes

- Histogram series is not rendered when binding with null value contained data (TFS:332595)

### Improvements

- Added chart animation, the basic animation options is controlled by AnimationSettings
  property. To enable animation just set chart.AnimationSettings = AnimationSettings.All,
  use AnimationLoad and AmimationUpdate properties for advanced settings.
- Add vertical scrolling to legend (FlexChartBase.LegendScrollBars and
  FlexChartBase.LegendScrollBarStyle properties).

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Extra separator value is added after the last selected item when setting more than one character or string value to the separator value. (TFS-313805)
- [C1MultiSelect] Selected Items are automatically unchecked when click multiple times on the MultiSelect DisplayArea. (TFS-326937)
- [C1MultiSelect][C1TagEditor] Do not allow set seperator is empty string. (TFS-342455)
- [C1MultiSelect] Content of SelectedItem is not correctly showed in C1MultiSelect display area when adding item to C1MultiSelect using Collection Editor at Design Time. (TFS-314141)

# Release version 10.0.20183.601 - 09/11/2018

## C1.UWP.Calendar

### Bug fixes

- [C1Calendar] "DayOfWeekFormat" property does not work correctly when setting "dddd" format (TFS-341703).

## C1.UWP.Document

### Bug fixes:

- Last row of the detail section is not exported to excel format correctly when there are blank fields in the detail section. (TFS:341531)
- PDF files with semitransparent text can be rendered incorrectly in some cases. (TFS:318022)

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect] Item is still shown in header part of C1MultiSelect when using remove() method. (TFS-310269)
- [C1MultiSelect][C1CheckList] "UnSelectAll" text is shown instead of "SelectAll" text in C1MultiSelect when no data is binding and ShowSelectAll = "True" at Design Time/RunTime (TFS-311407)

### Improvements

- [C1MultiSelect] Enhancement: Request to add feature for limiting the maximum number of checked items. (TFS-338970)

## C1.UWP.Maps

### Improvements

- [C1Maps] Request to provide a way to rotate the C1Maps. (TFS 203133)

# Release version 10.0.20183.600 - 08/28/2018

## C1.UWP.ExpressionEditor

### Bug fixes

- [ExpressionEditor] Function in Categories Selection's Items List cannot be chosen by pressing "Enter" key. (TFS-327546)
- [ExpressionEditor] Categories Selection's Item List of ExpressionEditor Panel is not refresh immediately when remove the function of Categories Selection's Item List. (TFS-327556)

## C1.UWP.FlexGrid

### Improvements

- Added SortAscendingIconTemplate/SortDescendingIconTemplate to present the sort icon when the column is sorted.
- Added new GroupHeaderConverter class. You can use this converter to customize default formatting.

## C1.UWP.FlexViewer

### Improvements

- Added C1FlexViewerPane.NavigateToOutlineNode method that allows to navigate to a specific outline node from code. (TFS:342529)

## C1.UWP.RichTextBox

### Bug fixes:

- [C1RichTextBox] Incorrect Font size for suggestion when C1RichTextBox when zoom value is changed.(TFS-339376)

## C1.UWP.Schedule

### Improvements:

- Added new appointment availability status "Working Elsewhere".

## C1.UWP.Word

### Improvements

- Support TOC objects (added RtfSdtContent, RtfTocField and RtfPageRefField calsses).

# Release version 10.0.20182.597 - 07/30/2018

## C1.UWP.FlexGrid

### Bug fixes

- [FlexGrid] Row/Column still can be resized even setting of "e.Cancel = true" in ResizingRow/ResizingColumn event. (TFS-256534)
- [FlexGrid] Row/Column still can be resized even setting of "e.Cancel = true" in ResizingRow/ResizingColumn event. (TFS-256534)

# Release version 10.0.20182.596 - 07/25/2018

## C1.UWP.FlexViewer

### Bug fixes

- An exception occurred occasionally in HamburgerButtonSizeChanged(). (TFS:334278)

# Release version 10.0.20182.592 - 06/25/2018

## C1.UWP.Document

### Bug fixes:

- Certain PDF files can not be exported to HTML. (TFS:328491)
- Certain PDF files can not be loaded by C1PdfDocumentSource. (TFS:250109)

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Selected Item can be removed by backspace in DisplayMode=Tag when setting IsEditable=false at Design Time.(TFS-310087)
- [C1TagEditor] Tag are wrapped in Display Area although TagWrapping is unckecked in Tag DisplayMode.(TFS-324462)

# Release version 10.0.20182.591 - 06/19/2018

## C1.UWP.FlexChart

### Bug fixes

- "NullReferenceException" is thrown in designer when adding MACD indicator series (MACD and MACD Histogram) (TFS:291258).
- Clicking on Legend items of FlexPie does not getting selected the corresponding point in FlexPie (TFS:152465).
- LineMarker does not parses the Content string to replace keywords with corresponding values (TFS:271136).
- Fixed incorrect property spelling (TFS:328057).

## C1.UWP.Input

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Editing of Selected Item cannot be able to cancel by pressing "Esc" Key in DisplayArea.(TFS-323956)
- [C1MultiSelect][C1TagEditor] Selected Item is not properly shown and clipped at Display Area when display mode is set "Tag" in original width and height.(TFS-323085)
- [C1MultiSelect] SelectedIndex is not shown correctly when SelectAll the MultiSelect Dropdown items.(TFS-309028)
- [C1MultiSelect] Unlike WinForm, KeyBoard Navigation of MultiSelect cannot properly work in "Single" Selection Mode. (TFS-323133)
- [C1TagEditor] No scrollbar is shown when the Text/Tag DisplayMode texts are exceed the display area although TapWrapping is checked.(TFS-308420)
- [C1MultiSelect][C1TagEditor] Application Break and control's size is changed when drag/drop the same control to Form for the second time.(TFS-327078)

# Release version 10.0.20182.590 - 06/07/2018

## C1.UWP

### Bug fixes

- [C1TreeView] C1TreeView cannot be expanded / collapsed by using keyboard when it has been focused by tabulation. (TFS-15883)

## C1.UWP.Document

### Improvements:

- PDF files containing dashed lines can be rendered incorrectly. (TFS:327643)
- Added support (PDF view) of CFF type fonts (Type1).

## C1.UWP.ExpressionEditor

### Improvements

- Added C1ExpressionEditor.InsertCommand property.
- Use C1WrapPanel as container for operator buttons in the ExpressionEditorPanel. (TFS:325471)

## C1.UWP.FlexGrid

### Bug fixes

- System.ArgumentOutOfRangeException when changing DataContext while checkbox cell has focus. (TFS-325516)

## C1.UWP.FlexReport

### Bug fixes:

- Report rendered incorrectly if all records of report's datasource filtered out by Filter expression. (TFS:323981)

## C1.UWP.Input

### Breaking changes:

- [C1MultiSelect][C1CheckList] Changed SelectedItems property type form IEmunable to IList<object>/IList in WPF/UWP.
  SelectedItems Property as readonly, use SelectedItems.Add method instread of set SelectedItems value.

### Bug Fixes:

- [C1MultiSelect][C1TagEditor] Selected Item Tag is not properly shown and clipped in DisplayArea when SelectionMode is set "Tag" at MultiSelect's original width and height.(TFS-322963)
- [C1MultiSelect][C1CheckList] KeyNavigation[Up/Down key] is not correctly worked while selecting items.(TFS-323191)
- [C1MultiSelect] System.NullReferenceException is thrown when entering text after deleting selected item in DisplayArea.(TFS-323970)
- [C1MultiSelect] System.OutOfMemoryException is thrown when all text of Tag in Display Area are deleted at "Suggest" Autocomplete Mode. (TFS-323672)
- [C1MultiSelect] Suggestion filter Dropdown is shown with Transparent Color and Items cannot be seen clearly in DropDown.(TFS-324148)
- [C1MultiSelect] Cursor move to the left most position of DisplayArea after deleting one item using Backspace in "Text" DisplayMode.(TFS-323980)

# Release version 10.0.20182.589 - 05/21/2018

## C1.UWP

### Bug fixes

- [C1DropDown] MouseOverBrush is not shown when hover the mouse on Dropdown button.(TFS-308877)

## C1.UWP.BarCode

### Improvements

- Added new bar code types: MicroQRCode, ITF14, Code11, SSCC18, Telepen, Pharmacode, PZN, HIBCCode128, HIBCCode39, ISBN, ISSN, ISMN, Iata25, Bc412, Plessey, IntelligentMailPackage
- Added new options: MicroQRCodeOption

## C1.UWP.ExpressionEditor

### Breaking changes

- Added new method AddFunction into the IExpressionLexer interface.

### Improvements

- Added the AddFunction method to C1ExpressionEditor class. This method adds a custom function to engine of C1ExpressionEditor. (TFS-309412)
- Added C1ExpressionEditorPanel.Categories property to customizing categories of the expression items. (TFS-305001)

## C1.UWP.FlexChart

### Bug fixes

- FlexGrid axis minor tickmarks are now correctly based on the Axis.MinorTickMarks setting instead of Axis.MajorTickMarks setting.
- AxisX Labels are incorrect when binding with series.BindingX to string data type (TFS-315802)
- No Data point is plotted when setting invalid BindingX value (TFS-323122)
- TreeMap's data labels now support wrapping and trimming according to DataLabel.ContentOptions. The default value for content options is WordWrap. (TFS:320004)

### Improvements

- Added axis TimeUnits enum and Axis.TimeUnit property. Used in combination with Axis.MajorUnit, the Axis.TimeUnit property \
  allows expression of MajorUnit in terms of calendar periods such as Week, Month, Year instead of only days.
- Added Axis.LabelMin and Axis.LabelMax boolean properties which when true forces the labeling of axis extremes.
- Added axis grouping expand/collapse through the addition of the Axis.GroupVisibilityLevel property. The absolute value Axis.GroupVisibilityLevel \
  specifies the most expanded level of the groups moving away from the anchor. Positive values specify the anchor at the highest level, negative \
  values specify the anchor at level 1.
- Added public class DateTimeGroupProvider. This built-in class manages typical axis groupings for various dated axis durations.
- Added new C1.WPF.FlexChart.Extended.dll that includes various extended charting features.
- Added new Heatmap series class that allows to create different heatmap visualizations(C1.WPF.FlexChart.Extended.dll).
- Improved performance of area charts with large data in DirectX rendering mode.
- Added new FrequencyPolygon mode to Histogram series class that allows to show the frequency of original data as a polygon.
- Added new Ichimoku cloud overlay to FinancialChart
- Added new NormalCurve object to Histogram series class that allows to show a gaussian curve together with the histogram chart
- Improved LineMarker feature to allow moving/dragging after the position properties are specified

## C1.UWP.Input

### Breaking changes:

- [C1MultiSelect] Change inherit from C1ItemsControl to ItemsControl.
- [C1CheckList] Change inherit from C1ListBox to ListBox.
- [C1MultiSelect][C1CheckList] Unity SelectionMode property for C1MultiSelect and C1CheckList.
  For WPF as System.Windows.Controls.SelectionMode.
  For UWP as Windows.UI.Xaml.Controls.SelectionMode.
- [C1MultiSelect][C1CheckList] Changed Items property type form C1ItemsCollection to MS ItemsCollection.

### Bug Fixes:

- [MultiSelect] Inconsistent behaviors of MultiSelect Width are observed in UWP when dragdrop control to form toolbox.(TFS-313840)
- [C1MultiSelect] PlaceHolder text is shown in DisplayArea when changing DisplayMode from "Text" to "Tag".(TFS-315934)
- [C1MultiSelect] Selected Item contains space at first place is disappeared in Display Area and change to Uncheck state at dropdown when Focus is out of the Display Area .(TFS-314718)
- [C1CheckList] Selection highlight color didn't shown on keyboard navigation in C1CheckList. (TFS-310870)
- [C1MultiSelect] Selection highlight color is not shown in C1MultiSelect dropdown for keyboard navigation.(TFS-306449)
- [C1MultiSelect] Dropdown does not open/close using shortcut keys(F4/Esc/Spacebar) in C1MultiSelect dropdown.(TFS-308899)
- [C1TagEditor] Deleted Items are shown again in TagEditor when adding new Items in "Text" DisplayMode at RunTime.(TFS-316033)
- [C1MultiSelect] Dropdown items can not selected by "Enter" or "Spacebar" keys from keyboard in C1MultiSelect controls.(TFS-306448)
- [C1MultiSelect] Selected items and selection highlight color are not showed in display area and dropdown list although item is checked in dropdown part by using "Spacebar" key from keyboard.(TFS-315061)

### Improvements

- [C1MultiSelect][C1CheckList] Support set C1MultiSelect/C1CheckList's ItemsSource as grouped data source will show grouped items.
- [C1MultiSelect][C1CheckList] Add GroupStyle,IsGrouping and GroupStyleSelector properties for group feature.
- [C1MultiSelect][C1CheckList][C1TagEditor] Set default Width and Height of Input controls when drag and drop control to the form toolbox.(TFS-314538)
- [C1MultiSelect] Add AutoCompleteMode for C1MultiSelect, in AutoCompleteMode enums there are four values:
  None - Disables the automatic completion feature.
  Append - Appends the remainder of the most likely candidate string to the existing characters, highlighting the appended characters.
  Suggest - Displays the auxiliary drop-down list associated with the edit control. This drop-down is populated with one or more suggested completion strings.
  SuggestAppend - Applies both Append and Suggest options.
  If set AutoCompleteMode or AutoSuggestMode as None will disable current filter feature as behaviour as WF ComboBox.
  AutoCompleteMode default value as Suggest.
- [C1CheckList] Add Keyboard support for C1CheckList. C1CheckList keyboard behavior as follow:
  Type Up,Down,PageUp,PageDown,Home and End key if SelectionMode as Single and Expend navigation to specific item and selected it will raise SelectionChanged event.
  Type pre key with Ctrl with same selection mode, item show navigation highlting but not selected item until type Enter.
  Type pre key when SelectionMode as Multiple item show navigation highlting but not selected item until type Enter.
  Navigation highling color used as MouseOverBrush.
- [C1MultiSelect] Add Keyboard support for C1MultiSelect when suggest list popup.
  Type Up and Down will navigate to next or prevoius item.
  Type Enter will selected item form suggest list.
- [C1Tag] Add ContentUpdating event customer can cancel tag content updating and return to EditMode.
- [C1TagEditor] Add TagUpdating event customer can cancel current updating tag and return this specific tag to EditMode.
- [C1TagEditor] Enter key can add last input whatever tag mode and text mode.

# Release version 10.0.20181.588 - 04/18/2018

## C1.UWP.Document

### Bug fixes:

- Certain PDF files rendered incorrectly. (TFS:327010)

## C1.UWP.ExpressionEditor

### Bug fixes

- Tooltips of Expression was not shown when UnderlineError and SyntaxHighlighting is unchecked. (TFS-311388)

## C1.UWP.FlexGrid

### Bug fixes

- With SelectionMode = ListBox, resizing a non-selected row resizes selected rows too. (TFS-315795)

## C1.UWP.Word

### Bug fixes

- Content of "Export UI" page in the product sample "WordSample" are distorted in both Docx and RTF file. (TFS:253201)
- Unable to load Docx file into C1Word (invalid). (TFS:295050)
- Alignment of text and image in the MS document are missing when read/write in another C1WordDocument. (TFS:285688)
- Alignment and FontStyle of RTFParagraph are affected to the adjacent RTFString with different behavior in (.docx) and (.rtf) files. (TFS:276813)
- ForeColor of RTFParagraph are affected to the adjacent RtfDateField when save the document with (.rtf) format. (TFS:276823)
- Support text format Save (only text string in paragraphs) method.

# Release version 10.0.20181.587 - 03/09/2018

## C1.UWP.ExpressionEditor

### Bug fixes

- Operator Buttons in ExpressionEditor Panel are clipped in UWP ExpressionEditor. (TFS-312101)
- "English quotes" operator button is not shown in both Orientation when running the ExpressionEditor sample on WinPhone Device or Window Tablet. (TFS-312172)

## C1.UWP.FlexChart

### Bug fixes

- No data are not shown in StockChart sample and System.Net.WebException thrown (TFS-307167)

# Release version 10.0.20181.586 - 03/05/2018

## C1.UWP.ExpressionEditor

### Improvements

- Added toolbar button to enter English quotes.

## C1.UWP.Word

### Bug fixes

- Unable to properly read outline set in MS Word. (TFS:299297)

# Release version 10.0.20181.585 - 02/13/2018

## C1.UWP.Word

### Bug fixes

- Default font size of 'RtfParagraph' and 'RtfString' is getting smaller if using c1WordDocument.Clear() method and saving the document with (.docx) format. (TFS:305133)
- Font size is not retained in heading style text when loading and saving as .docx file using C1WordDocument. (TFS:305198)

# Release version 10.0.20181.584 - 02/05/2018

## C1.UWP.Document

### Bug fixes:

- Now C1DocumentSource.ShowPrintUIAsync() method uses C1DocumentSource.DefaultPrintOptions. (TFS:301482)

## C1.UWP.ExpressionEditor

### Bug fixes

- Request to provide Alphabetical order for the items of the categories selection. (TFS-292950)
- Items of the functions are shown with irrelevant order. (TFS-292950)

## C1.UWP.FlexChart

### Bug fixes

- DataLabels are not displayed although setting properties of Series.DataLabel (TFS-305752)
- Incorrect description of GroupStyle property is displayed in IntelliSense (TFS-306298)
- GroupStyle properties for numeric axis labels grouped by GroupProvider are not affected (TFS-306257)

### Improvements

- [C1FlexChart] Improved the performance of Histogram charts with large data source.
- [C1FlexChart] Improved DirectX rendering at high DPI screens.

## C1.UWP.FlexReport

### Bug fixes:

- Added property to C1FlexReport.BehaviorOptions (TFS: 295679)
  bool FireOnFormatForEachInstanceOfRepeatedGroupSection { get; set; }
  Gets or sets a value indicating whether the OnFormat script is fired
  for each instance of a repeated group section, or just once for the
  first instance.Applies only to groups with Repeat property set to true.

## C1.UWP.Pdf

### Bug fixes

- When saving a PDF document with FontType specified as Standard or TrueType causes unexpected rendering. (TFS:153782)
- When C1TreeView is outputted to C1PdfViewer, a garbled character appears. (TFS:306818)

# Release version 10.0.20181.583 - 01/22/2018

## C1.UWP.Document

### Improvements:

- Added C1DocumentSource.DefaultPrintOptions property allows to define default print options.
  Set C1DocumentSource.DefaultPrintOptions.PageScaling to FitToPrintableArea if document's margins
  are too small and less than printable margins of physical printer. (TFS:301482)

# Release version 10.0.20181.582 - 01/12/2018

## C1.UWP.Automation

### Bug fixes

- [WPF] Fixed scrolling and selection behavior in C1TabControl.
- [WPF] Fixed scrolling and selection behavior in C1FlexGrid.
- Fixed C1Calendar automation.
- Fixed C1TileView automation.

## C1.UWP.Excel

### Bug fixes

- Error "We found a problem with ..." is occurred in result excel (.xlsx) file when
  loading and saving an excel file that contains TabColor and formula. (TFS:303440)
- Back Color is not applied on the grid when load the excel file. Regression for
  TFS:200400, notice by Alexey Smorkalov. (TFS:301789)
- Request to add feature to select multiple sheets while saving the excel through
  C1XLBook. (TFS:293060)
- Hyperlinks in resultant excel file do not work in some special condition. (TFS:285089)
- C1Excel errors with .xlsm file. (TFS:291985)
- Invalid Excel OpenXml file (*.xlsx) exception is thrown on loading C1XLBook with xlsx
  created in LibreOffice. (TFS:295413)
- Request to provide information on cell styles in excel file when FlexGrid is saved
  using SaveExcel method. (TFS:289978)
- Text written by RTF format is not shown in exported excel file. (TFS:274741)
- Error at export the report with RTF format to excel file (.xls) (TFS:274980)
- A message box ‘We found a problem with some content in ...’ is shown when opening the result xlsx file. (TFS:305960)
- Backcolor of cell is applied as font color of cell in result .xls/.xlsx file. (TFS:306055)

### Improvements

- Added SelectedIndexes property for the XLSheet class (the index array of the sheets
  that is selected).

## C1.UWP.ExpressionEditor

### Breaking changes

- Added new method AddAlias into the IEngine interface.

### Bug fixes

- Blank tooltip is shown when hovering the mouse on ExpressionTextBox. (TFS-292325)

### Improvements

- Added support of field aliases (System.ComponentModel.DisplayNameAttribute and System.ComponentModel.DataAnnotations.DisplayAttribute).
- Aggregate functions with one argument works for all items from DataSource.
- Added alphabetical order for the items of the categories selection.

## C1.UWP.FlexChart

### Improvements

- [C1TreeMap] Added new NodeRendering, NodeRendered events to TreeMap
- [C1FlexChart] Added new SortDescending property to RangedHistogram
- [C1FlexPie,C1Sunburst] Data labels can be hidden or trimmed if their content is outside pie segment. Added new PieDataLabels.Overlapping property and corresponding enum PieLabelOverlapping.
- [C1FlexChart] Staggered axis labels. New Axis.StaggeredLines property.
- [C1FlexChart] Trim or wrap the overlapping axis labels. New members of OverlappingLabels enum: Trim and WordWrap.
- [C1FlexChart] Rotated data labels. New DataLabel.Angle property.
- [C1FlexChart] Series-specific data labels. New Series.DataLabel property.
- [C1FlexChart] Automatic positioning of data labels without overlapping. New 'Auto' member of LabelPosition enum.
- [C1FlexChart] Trim or wrap data label content. New DataLabel's properties: MaxWidth, MaxLines, ContentOptions and corresponding ContentOptions enum.
- [C1FlexChart] Control appearance of overlapped data labels. New DataLabel's properties Overlapping and OverlappingOptions and corresponding enums LabelOverlapping and LabelOverlappingOptions.

## C1.UWP.Input

### Improvements

- [C1MultiSelect] Beta version.

## C1.UWP.Word

### Bug fixes

- Unable to properly read outline set in MS Word (two part). (TFS:299297)
- (partly) RoundRectangleShape loosing rounded corner/text on saving to *.rtf/*/docx formats respectively. (TFS:303566)
- Bullet color is not retained when load the word document and save it as '.docx' using C1WordDocument. (TFS:303516)
- Extra space are added in heading style text when read and write in new C1WordDocument. (TFS:276701)
- 'KeyNotFoundException' is thrown when load and save the document contained image and bold style text. (TFS:303834)
- Font and Color of RtfParagraph added by AddParagraph () method are not affected in result (.docx) format. (TFS:303525)
- Unlike build 286, default font size of 'RtfParagraph' and 'RtfString' is getting smaller when saving the document with (.docx) format. (TFS:303502)
- Total page count number is not properly shown in exported .docx and .rtf files when loading the .docx file contained table. (TFS:302425)

# Release version 10.0.20173.581 - 12/19/2017

## C1.UWP.Automation

### Bug fixes

- Fixed broken UWP automation (TFS-298327).

## C1.UWP.ExpressionEditor

### Bug fixes

- System.ArgumentOutOfRangeException thrown on entering "Instr(" in expression box. (TFS-301118)

## C1.UWP.Word

### Bug fixes

- Unable to properly read outline set in MS Word. (TFS:299297)
- Text style in the original document is not retained when saving as .docx file in another document. (TFS:299372)
- Alignment of text and image in the MS document are missing when read/write in another C1WordDocument. (TFS:285688)
- Alignment and FontStyle of RTFParagraph are affected to the adjacent RTFString with different behavior in (.docx) and (.rtf) files. (TFS:276813)
- ForeColor of RTFParagraph are affected to the adjacent RtfDateField when save the document with (.rtf) format. (TFS:276823)
- FlexReport exported to docx generates the entire document in bold and italics. (TFS:296298)
- Black rectangle is shown when loading the rtf file contained table and saving as '.rtf' file. (TFS:301005)
- Bullet are not retained when load the word document and save it as '.docx' using C1WordDocument. (TFS:300997)

# Release version 10.0.20173.579 - 11/20/2017

## C1.UWP.FlexChart

### Bug fixes

- The 'Binding' property is mandatory for the 'Histogram' series to be plotted, even though it has no effect (TFS-295111)
- Text doesn't get displayed on Polygon Annotation with Attachment set to Relative (TFS-292702)

## C1.UWP.FlexGrid

### Bug fixes

- A Refresh Issue when drag the horizontal Srollbar. (TFS-296582)

## C1.UWP.Schedule

### Improvements:

- Made some changes in default xaml for better performance.
- Improved layout of short appointments in views with small visual interval scale. (Tfs 295043)

## C1.UWP.Word

### Bug fixes

- Column layout in the word document is not retained when read and write it in another document. (TFS:270490)
- (partly) Bullet are not retained when load the word document and save it in another document. (TFS:269921)
- Center alignment of text are slightly missing in rtf file when read the word document and write in C1WordDocument. (TFS:271096)
- Loading and saving a file with newline removes newline characters. (TFS:281258)
- Unable to load Docx file into C1Word (invalid). (TFS:295050)

# Release version 10.0.20173.576 - 10/24/2017

## C1.UWP.FlexChart

### Bug fixes

- "InvalidOperationException" with "Sequence contains no elements" message is thrown when setting 0 to Period of CCI and WilliamsR indicators (TFS-291254)
- DataLabel is not shown in exported svg image of TreeMap (TFS-291269)
- "IndexOutOfRangeException" is thrown when setting Period=1 and Scaling=Dynamic (TFS-291870)
- Datalabels in floating bars for Class A series are displayed the same as Class B series in 'FloatingBarChart' sample (TFS-291557)

## C1.UWP.FlexViewer

### Bug fixes

- Highlighted selection and the current page number were sometimes not in sync. (TFS:290272)

# Release version 10.0.20173.575 - 10/16/2017

## C1.UWP.FlexChart

### Bug fixes

- Legend text is rendered unparalleled to Legend icon in exported svg file of FlexChart (TFS-290331)
- 'NullReferenceException' is thrown when adding empty series, RangMode='ATR' and ChartType='Renko' / 'Kagi' (TFS-269448)
- Reflection is not used when binding to collection of Point object (TFS-291194)
- Fixed exception in DataManipulation sample (TFS-291186)

# Release version 10.0.20173.574 - 10/04/2017

## C1.UWP.FlexChart

### Bug fixes

- AxisY labels and bars are overlapped in exported SVG image of FlexChart with 'Bar' chart type (TFS-277443)

## C1.UWP.RichTextBox

### Bug fixes:

- A row and text of table cell that contains list will disapper after export and import from RTF. (TFS-278044)

# Release version 10.0.20173.572 - 09/22/2017

## C1.UWP.ExpressionEditor

### Improvements

- First Release.

## C1.UWP.Extended

### Bug fixes

- [C1ColorPicker] System.ArgumentOutOfRangeException occurrs while setting of Margin property in C1ColorPicker and opening colorPicker dropdown and then resizing MainPage. (TFS-281345)

## C1.UWP.FlexChart

### Bug fixes

- 'NullReferenceException' is thrown in designer when adding secondary axis to series with CandleStick/HighLowOpenClose ChartType (TFS-280199)
- [Win10 1703] Data points are not plotted when setting series's ChartType='CandleStick' / 'HighLowOpenClose' (TFS-280214)
- [Win10 1703] Data series exceed boundary of plot area when setting ChartType='Area' (TFS-281039)
- For Logarithmic axes, setting Axis.Max does not restricts the axis scale to the 'Max' value (TFS-284566)
- Removed the advanced options in HistogramSeries (TFS-289099)

### Improvements

- [C1FlexChart] Implement Histogram / RangedDiagram chart types
- [C1FlexChart] Implement Step / StepArea / StepSymbols chart types
- [C1FlexChart] Use point index instead of series index as parameter of LabelRendered / LabelRendering events
- [C1FinancialChart] Added new chart type "PointAndFigure". The demo page for new chart type added to FinancialChartExplorer sample.
- [C1FlexChart] Added new FloatingBarChart samples.

## C1.UWP.FlexGrid

### Improvements

- Added MarqueeColor property to define custom marquee color.Note, you must set ShowMarquee = "True" then you can see it.

## C1.UWP.InputPanel

### Improvements

- Add 'TextWrapping' to C1InputTextBox.

## C1.UWP.Word

### Bug fixes

- C1WordDocument not able to load RTF File containing an Image (part 2 "1.rtf" file). (TFS:277877)

# Release version 10.0.20173.569 - 08/21/2017

## C1.UWP.FlexGrid

### Bug fixes

- Merging does not work correctly when there are less than 2 rows in the grid.(TFS-278963)

## C1.UWP.InputPanel

### Bug fixes

- Number in page textbox is shown as '0' while setting of 'AutoCommit' as 'False' in bound InputPanel. (TFS-278744)

## C1.UWP.RichTextBox

### Bug fixes:

- Application crashes while setting of margin as '409'. (TFS-278940)

# Release version 10.0.20172.571 - 09/05/2017

## C1.UWP.FlexGrid

### Bug fixes

- Application crashes at setting FrozenRows property. (TFS-281218)

## C1.UWP.FlexViewer

### Bug fixes

- Restored ZoomFactor value at runtime if it was set while the ZoomMode property is not Custom. (see TFS:283789)

### Improvements

- Added the LimitSearchToCurrentPage property indicating whether the text search should be limited to current page.
- ZoomFactor property is now zooming from center of the control at runtime. (TFS:284517)

## C1.UWP.Word

### Bug fixes

- Loading and saving a file with newline removes newline characters. (TFS:281258)
- C1Word not able to load file (*.docx and *.rtf) containing table. (TFS:279239)
- Request to provide information on changing fonts without adding new paragraph and adding markers with "AddParagraph". (TFS:274137)
- RTFLineBreak above the RTFTable is effected to the first row of table when save the document with docx format. (TFS:272451)
- Request to provide information on changing fonts without adding new paragraph and adding markers with "AddParagraph". (TFS:274137)
- System.FormatException is thrown when load the word file contain bullet and use the C1.C1Word.2dll. (TFS:269585)
- System.FormatException occurred when load the certain specific file. (TFS:269598)
- Footer are clipped in exported Word file with docx format. (TFS:268805)
- Checkmark for some check mark style are not shown in expored word file. (TFS:255387)
- CheckedSymbol are shown as number instead of CustomSymbol in exported word file. (TFS:255389)

# Release version 10.0.20172.570 - 08/28/2017

## C1.UWP

### Bug fixes

- [C1NumericBox] "System.IndexOutOfRangeException" occurred while clicking increment/decrement button in C1NumericBox and then pressing Spacebar key from keyboard. (TFS-280493)

## C1.UWP.Extended

### Bug fixes

- [C1ColorPicker] System.ArgumentNullException occurs when small letter(eg.f) is pressed from keyboard in HexColorBox of C1ColorPicker. (TFS-279622)

## C1.UWP.FlexChart

### Bug fixes

- [FlexChart][Regression]Candlestick symbols are rendered while setting e.Cancel=True in series SymbolRendering event handler

# Release version 10.0.20172.568 - 08/14/2017

## C1.UWP.FlexChart

### Bug fixes

- [FlexChart] AxisLine is covered by AxisScrollBar when hiding all the series by toggling legend (TFS-276972)
- [FlexChart] Incorrect axis format and series plotted is shown when setting DateTime type to BindingX in C1FlexChart which has series with Secondary AxisX (TFS-276888)

## C1.UWP.Gauge

### Bug Fixes:

- Setting Background Color does not work when customizing the shape of C1RadialGauge.(TFS-275263)

## C1.UWP.InputPanel

### Bug fixes

- Multiple issues are observed while setting big FontSize to InputPanel. (TFS-264781)
- Setting CurrentItem property doesn't get reflected in InputPanel. (TFS-277833)

## C1.UWP.RichTextBox.AppBar

### Improvements

- Make C1ButtonTool be inherited from AppBarButton, so that it could be used in CommandBar PrimaryCommands and SecondaryCommands.
- Remove IsChecked property and use AppBarToggleButton.IsChecked in C1ApplicationBarToggleButton.
- Add default Icon/Label for every tool for better appearance. The Label supports localization.

# Release version 10.0.20172.567 - 07/31/2017

## C1.UWP

### Bug fixes

- [DropDown] Arrow toggle button disappears and seperator line always locates at center instead of changing the whole height adaptive with the dropdown's height. (TFS-243253)

## C1.UWP.FlexChart

### Bug fixes

- [C1FinancialChart][Regression] "System.NullReferenceException" is thrown when the "Binding"contains only close values in RSI indicator (TFS-269517)

## C1.UWP.RichTextBox

### Bug fixes:

- RemoveShortcut method does not work on Shift+Insert/Ctrl+V key combination.(TFS-266854)

# Release version 10.0.20172.565 - 06/28/2017

## C1.UWP.Document

### Bug fixes

- Bound images in the flexreport are not cleared in exported pdf file. (TFS:269973)

# Release version 10.0.20172.564 - 06/27/2017

## C1.UWP.Excel

### Bug fixes

- Different output file being generated for SaveCsv() method using 2016v3 and 2017v1
  builds. (TFS:268424)
- Location of merged cells in saved excel file changes when a row's height/column's
  width is changed after merging in C1Excel. (TFS:268784)
- Request to provide information on how to use XLReferenceMode Enum in C1Excel.
  (TFS:242729)
- When a .xlsx file is load and saved just as it is, the user definition format of
  a cell changes. (TFS:251891)
- C1XLBook throws an unhandled exception of type 'System.ArgumentException' when
  loading a xslx file. (TFS:245883)
- Fixed work with print area (Excel: Seting print area). (TFS:204542)
- Request to improve performance for saving excel file. (TFS:253350)

### Improvements

- Added support XLReferenceMode.R1C1 (and ReferenceMode property for C1XLBook) for
  C1Excel (Request: TFS:242729)
- Added UseDefaultCsvEncoding property in C1XLBook (use the default encoding for CSV
  files), for Japanese version true by default.

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] DataLabels are overlapped in bar stacked group if same values are at the same group (TFS-268756)
- [C1FinancialChart] ArgumentException is thrown when add two series with same data and ChartType='LineBreak' (TFS-268952)
- [C1TreeMap] ArgumentException occurs when C1TreeMap is added many items at design time by setting DataLabel.Border="True" and without setting Width property to C1TreeMap (TFS-269640)

## C1.UWP.FlexGrid

### Bug fixes

- Grid is not refreshing properly and you lose visibility of the frozen content when headers are merged. (TFS-268957)
- Setting Column.AllowMerging to merge ColumnHeaders vertically causes an unhandled exception. (TFS-268998)
- Unhandled exception is thrown when headers are merged and you freeze some columns. (TFS-268955)

## C1.UWP.FlexReport

### Bug fixes:

- Records of DataSource can be filtered incorrectly in certain scenario. (TFS:269599)

## C1.UWP.Word

### Bug fixes

- Footer are clipped in exported Word file with docx format. (TFS:268805)
- Text style in the original document is not retained when save it in another document. (TFS:268303)
- Header and footer are not shown when load the word document and save it in another document. (TFS:268381)
- FormatException is thrown when a word document is loaded. (TFS:261763)
- Image are not displayed in Docx format. (TFS:262936)
- Alignment of picture is not effected with Docx format. (TFS:263451)
- Ellipse,Arc,Beziers and line shapes are not shown in output documents. (TFS:215107)

# Release version 10.0.20172.563 - 06/20/2017

## C1.UWP.Document

### Bug fixes

- Export to TIFF takes much time. (TFS:266122)

# Release version 10.0.20172.562 - 06/19/2017

## C1.UWP.Document

### Bug fixes

- Export to BMP takes too much time. (TFS:266122)

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexPie] Slices in FlexPie are not rendered correctly when binding with negative value (TFS-265305)
- [C1FlexChart] DataLabels are overlapped when values at Y-Axis are the same in the same stacked group. (TFS-265756)
- [C1FlexChart] Fixed problem with minor grid lines/ticks when number of major ticks is less than 2. (TFS-219316)
- [C1FinancialChart] IndexOutOfRange exception thrown when using DateTime X-axis values for Stochastic oscillator (TFS-261840)
- [C1FinancialChart] MovingAverages are not getting rendered on a CandleStick/HLOC chart Fixed need review (TFS-260556)
- [C1FlexChart] LineMarkers cannot be dragged after resizing the chart if all the series are plotted on a secondary Y-axis. (TFS-259891)

### Improvements

- [C1FlexChart] Added new 'ContentCenter' property to Polygon annotation to control the location of the content. (TFS-253917)
- [C1TreeMap] Added new C1TreeMap control for visualization of hierarchical data.

## C1.UWP.Word

### Bug fixes

- System.Runtime.InteropServices.COMException is thrown when load the rft file
  contained image. (TFS:267942)

# Release version 10.0.20172.561 - 06/12/2017

## C1.UWP.Document

### Bug fixes

- System.Exception occurred when apply certain paper size to the C1DocumentSource derived classes. (TFS:264744)
- Image in the flexreport file is not shown in the exported pdf file. (TFS:266069)

## C1.UWP.FlexViewer

### Bug fixes

- Got rid of the NullReferenceException when the DocumentSource is regenerated.
- Catched exceptions that may occur while printing the document. (see TFS:264265)
- Unlike the WPF version, context menu of C1FlexViewer cannot be opened with "Shift+F10". (TFS:264851)
- Context menu was shown on the boundary of C1FlexViewer if opened with the Menu key. (TFS:264858)

### Improvements

- Added the HyperlinkClicked, HyperlinkHovered, OutlineClicked events to C1FlexViewerPane. (TFS:259423)

## C1.UWP.Word

### Bug fixes

- PageBreak is not effected in output docx file if the C1WordDocument contain RTFPicture
  and RTFTable. (TFS:251877)
- RtfLineBreak between RTFTable and RTFPicture is not effected in output docx file.
  (TFS:251845)
- "FirstLineIndent" property is not effected in output document when save the
  C1WordDocument with docx format. (TFS:251784)
- "Can't Open" error is thrown when save the C1WordDocument contained RTFHeader and
  RTFFooter with docx format. (TFS:251776)
- Image drawn by "DrawMetaFile" method is not shown when read and write in another word
  document. (TFS:249571)
- CheckedSymbol are shown as number instead of CustomSymbol in exported word file.
  (TFS:255389)
- Checkmark for some check mark style are not shown in expored word file. (TFS:255387)
- FormatException is thrown when a word document is loaded. (TFS:261763)
- Image are not displayed in Docx format. (TFS:262936)
- Alignment of picture is not effected with Docx format. (TFS:263451)
- Image drawn by "DrawMetaFile" method is distorted when read and write in another word
  document with rtf format. (TFS:263844)
- Color of image drawn by "DrawMetaFile" method is not retained when read and write in
  another word document. (TFS:263860)
- Ellipse,Arc,Beziers and line shapes are not shown in output documents. (TFS:215107)

# Release version 10.0.20172.560 - 06/05/2017

## C1.UWP.Document

### Bug fixes

- Error is shown when export the flexreport file contained RTF field to the PDF file. (TFS:263912)
- System.Exception occurred when apply certain paper size to the C1DocumentSource derived classes. (TFS:264744)
- Image in the flexreport file is not shown in the exported pdf file. (TFS:266069)

## C1.UWP.InputPanel

### Bug fixes

- Arrow toggle buttons are not visible in C1InputDateTimePicker and C1NumericBox while setting AutoGenerate="False" in C1InputPanel. (TFS-261708)

# Release version 10.0.20172.559 - 05/27/2017

## C1.UWP.Document

### Bug fixes

- Blank pages is displayed by the C1PdfDocumentSouce if document is protected with password from modify. (TFS:260561)

## C1.UWP.Excel

### Bug fixes

- Unlike previous build, the excel file generated by C1Excel cann't be opened if the
  cell background is black. (TFS:260205)
- Unlike previous build, the excel file cann't be opened if loading .xls file and
  saving in .xlsx (OpenXml) format. (TFS:260209)

# Release version 10.0.20172.558 - 05/23/2017

## C1.UWP.Excel

### Bug fixes

- When a .xlsx file is load and saved just as it is, the user definition format of a
  cell changes [part 2]. (TFS:251891)
- Request to improve performance for saving excel file. (TFS:253350)

## C1.UWP.FlexGrid

### Improvements

- Added support for RowDetailsTemplate. Note, it is not supported for hierarhical representation when ChildItemsPath property is set.

# Release version 10.0.20172.556 - 05/10/2017

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] NullReferenceException occurs at design page while adding new series.(TFS-239117)
- [C1FlexChart] In Direct2D RenderMode,FlexChart placed in a C1DockTabItem behaves incorrectly on changing displayed data or resizing application window. (TFS-250139)

### Improvements

- [C1FlexChart] Request to provide feature to create Stacked groups in FlexChart. (TFS-215718)
- [C1FlexPie] Legend text is not showed with multiple lines and FlexPie is showed as very small when setting the Legend text to long text. (TFS-204491)

# Release version 10.0.20171.557 - 05/18/2017

## C1.UWP.FlexGrid

### Bug fixes

- Unhandled exception when cell of second column is selected after selecting a cell of first column with touch and RowHeaders are hidden. (TFS-258000)

# Release version 10.0.20171.553 - 04/21/2017

## C1.UWP.Calendar

### Bug fixes

- [C1LoopPanel] Current plus succeeding day/week/workweek/month are shown on Schedule for any view type (TFS-253176).

## C1.UWP.Excel

### Bug fixes

- Table border is not rendered in output .xlsx file. (TFS:253473)

## C1.UWP.FlexGrid

### Bug fixes

- ColumnHeader Backcolor Issue (TFS-253361)

## C1.UWP.InputPanel

### Bug fixes

- Unlike WPF version, ForeForeground property is not applied to Navigation number and combobox items in C1InputPanel. (TFS-251782)
- Menu on the header of InputPanel is not dim while setting of 'IsEnabled' as 'False'. (TFS-251846)

# Release version 10.0.20171.552 - 04/06/2017

## C1.UWP.Excel

### Bug fixes

- Garble texts are shown in output .xls file while loading and saving of the border
  style containing .xls/.xlsx to C1Excel. (TFS:251734)
- When a .xlsx file is load and saved just as it is, the user definition format of
  a cell changes. (TFS:251891)
- C1XLBook throws an unhandled exception of type 'System.ArgumentException' when
  loading a xslx file. (TFS:245883)
- Fixed work with print area (Excel: Seting print area). (TFS:204542)
- Numeric value item is replaced by character "GyyyyNyyyyRAL" in saved CSV file.
  (TFS:251863)

### Improvements

- Added support XLReferenceMode.R1C1 (and ReferenceMode property for C1XLBook) for
  C1Excel (Request: TFS:242729)

## C1.UWP.FlexReport

### Breaking Changes

- Method C1FlexReport.Load(XmlDocument doc, string reportName) was renamed to C1FlexReport.LoadFromXmlDocument(XmlDocument doc, string reportName). (TFS:250414)

## C1.UWP.InputPanel

### Bug fixes

- 'Header' of C1InputTextBox/C1InputComboBox/C1InputBase is disappered. (TFS-251397)

## C1.UWP.Schedule

### Improvements:

- Default xaml has been cleaned up.

## C1.UWP.Word

### Bug fixes

- "The component cannot be found" exception is thrown when open "Images" page
  in the C1Word product sample. (TFS:251568)

# Release version 10.0.20171.551 - 03/27/2017

## C1.UWP.FlexViewer

### Bug fixes

- Red wiggly line is shown under the searched keyword. (TFS:250576)
- Thumbnails flicker while typing text into the search box. (TFS:250778)

## C1.UWP.InputPanel

### Bug fixes

- Unlike WPF version, navigation buttons are rendered continuously and lost their borders when NumericButtonStyle is applied. (TFS-250710)

## C1.UWP.Pdf

### Bug fixes

- Attempting to create an encrypted C1PdfDocument with a user password and Security.Encryption set to PdfEncryptionType.Standard128 crashes with index out of range. (TFS:253903)

# Release version 10.0.20171.550 - 03/13/2017

## C1.UWP.FlexReport

### Bug fixes:

- If Expression of CalculatedField references another calculated fields then its value can be calculated incorrectly. (TFS:239612)

### Improvements:

- Added methods to load C1FlexReport from XDocument:
  public void Load(XDocument doc, string reportName)
  public void Load(XDocument doc, string reportName, out bool converted)

## C1.UWP.FlexViewer

### Bug fixes

- Page thumbnails were cut if size of the first page is smaller than for the subsequent pages.

### Improvements

- Implemented deferred rendering for the page thumbnails.

## C1.UWP.InputPanel

### Improvements

- Support Ctrl+Left / Ctrl+Right.
- Expose C1DataPager properties (DisplayMode, NumericButtonStyle​) to C1InputPanel.

## C1.UWP.Maps

### Breaking changes

- The SOAP Services will be retired on June 30, 2017. We updated to use REST service in C1Maps component. (TFS 239591)
  Please refer to the following links:
  https://blogs.bing.com/maps/June-2016/Bing-Maps-V8-Web-Control-Released
  https://www.microsoft.com/maps/discon-control-migrat-guide.aspx

# Release version 10.0.20171.549 - 02/26/2017

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexPie] Multiple issues are observed when setting some value to DataLabelPosition , Offset, SelectedItemOffset and 1 to InnerRadius. (TFS-244411)
- [C1FlexPie] IndexOutOfRangeException is thrown by shrinking form size when DataLabelPosition is set to any position other than 'None'. (TFS-243301)

# Release version 10.0.20171.548 - 02/24/2017

## C1.UWP

### Bug fixes

- [C1DropDown] Exception shows when "IsDropDownOpen" property is set to "True" at design time. (TFS-243236)

# Release version 10.0.20171.547 - 02/20/2017

## C1.UWP.Bitmap

### Bug fixes

- Fixed a bug with image DPI in the Import(C1Bitmap) and CreateImage methods of C1Bitmap.

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] AxisY of of series is not closed to MajorGrid.(TFS-239281)
- [C1FlexChart] ErrorBar is disappeared when changing the ChartType to "Area" or "SplineArea" in C1FlexChart. (TFS-235045)
- [C1FlexChart] Part of DataSeries exceed PlotAreas is not cut off in FlexChart with
  setting FlexChart.AxisY.Min/Max value.(TFS-239311)

## C1.UWP.FlexReport

### Bug fixes:

- Exception can occurs during report rendering if report contains SubreportField and SubreportFilter expression is used.(TFS:239612)

# Release version 10.0.20171.546 - 02/13/2017

## C1.UWP.Document

### Bug fixes

- Exception can occurs during rendering PDF documents if C1PdfDocumentSource.UseSystemRendering is false. (TFS:238041)
- C1PdfDocumentSource.LoadFromStreamAsync() can fails with exception in some scenarios. (TFS:238086)

## C1.UWP.Excel

### Bug fixes

- Part 2: Width and Height of image is not retained in output .xls/.xlsx file.
  (TFS:236105)
- System.ArgumentException occurs in C1.WPF.Excel.4.dll when loading of .xslx file
  which contains JPN text. (TFS:238446)

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] Dotted line of Series is shown as solid line in exported SVG image
  while setting of 'StrokeDashArray' property.(TFS-236020)

## C1.UWP.Pdf

### Bug fixes

- Result pdf file with arabic text have some scrambled. (TFS:238493)

# Release version 10.0.20171.545 - 02/08/2017

## C1.UWP

### Breaking changes

- [C1TreeViewItem] Removed HeaderEditor template part from the C1TreeViewItem control. It should not affect control functionality in any way.

## C1.UWP.Document

### Bug fixes

- Fail to export exception is thrown when export the pdfdocument to excel file. (TFS:236246)

## C1.UWP.Excel

### Bug fixes

- An Exception thrown when load an Excel file by C1Excel (part 2: 元ファイル20161029_nv1.xlsx). (TFS:213273)
- Width and Height of image is not retained in output .xls/.xlsx file. (TFS:236105)
- C1Excel replaces "@" symbol to new line"\n". [next fix for CSV format] (TFS:235074)

## C1.UWP.FlexChart

### Improvements

- [C1FlexChart] Support PlotAreas.
- [C1FlexChart] Support axis binding.

## C1.UWP.FlexViewer

### Bug fixes

- Added reference to C1.UWP.Bitmap.dll. (TFS:236146)
- Displayed the notification status string while exporting the document. (TFS:236680)

## C1.UWP.Word

### Bug fixes

- "System.InvalidCastException" exception is thrown when load the rtf file contained table. (TFS:236199)

# Release version 10.0.20171.544 - 01/25/2017

## C1.UWP

### Bug fixes

- [C1TabControl] While selecting a tab item in C1TabControl only the text in it get selected which does not looks consistent in the tab strip. (TFS-228254)

## C1.UWP.Document

### Breaking Changes:

- Now C1.UWP.Document references C1.UWP.Bitmap.

### Improvements:

- Added property:
  bool C1PdfDocumentSource.UseSystemRendering { get; set; }
  Allows to select the engine used to render PDF files.
  True indicates that the system API available
  on Windows 10 will be used. It provides better fidelity but
  does not support text search or selection.
  False (the default value) indicates that the built-in renderer will be used.
  It supports text search and selection, but is currently less
  accurate.

## C1.UWP.Excel

### Bug fixes

- C1Excel replaces "@" symbol to new line"\n". (TFS:235074)
- Multiple issues are observed when loading .xlsx file that contains cells
  with thousand separators and 11 decimal values. (TFS:208468)
- Unlike build 216,'I' cursor is not shown in c1FlexGrid edit mode when loading .xlsx
  excel file to c1FlexGrid by using LoadExcel() method. (TFS:228390)
- Height of Image is reduced when image is added and saved to excel file using
  C1Excel. (TFS:223304)
- Error 'Invalid Excel OpenXml file' is occurred on opening of an excel file contains
  TabColor and formula after saving as another one. (TFS:197450)

## C1.UWP.FlexChart

### Bug fixes

- Legend text are rendered not evenly to legend icon when exporting FlexChart to SVG format.(TFS-227954)
- Part of series is covered the AxisY when exporting FlexChart to SVG format.(TFS-234505)

## C1.UWP.FlexGrid

### Improvements

- Improved loading and scrolling performance.
- Default value of GridLinesVisibility property is changed to GridLinesVisibility.All.

## C1.UWP.FlexViewer

### Improvements

- Added the UseIncrementalSearch property to C1FlexViewer indicating if "search as you type" method of search should be used.
- Added the MatchWholeWord property to C1FlexViewer indicating if search should match the whole word.
- Added the MatchCase property to C1FlexViewer indicating if search should match case.
- Added the CollectSearchHistory property to C1FlexViewer indicating if the search history should be collected and shown when the user types in the search box.
- Added the SearchHistory runtime property to C1FlexViewer returning the list of the collected search strings.
- The error message text is shown on a page that can not be rendered because of an internal error.

## C1.UWP.Word

### Bug fixes

- System.FormatException is thrown when load the certain docx file. (TFS:227601)
- Text are jump to the new line in exported docx file when RenderObjects use BaseNine fonts. (TFS:235816)

# Release version 10.0.20171.543 - 01/13/2017

## C1.UWP

### Bug fixes

- [NumericBox] Selection flicker in text area of NumericBox while
  increment/decrement performs by using Up/Down arrowkeys. (TFS-218002)
- [C1TabControl] Enabling/Disabling the C1TabControl resets the selected tab to the tab at index 0. (TFS-228152)
- [C1NumericBox] If "Format" property is set as Percent(P0), not able to delete all digits by pressing "Delete" repeatedly.(TFS-19012)

## C1.UWP.Bitmap

### Improvements

- Added the CreateImage method to C1Bitmap which creates the internal image of the given size with uninitialized content.
- Added the Import(C1Bitmap) method for more efficient copying the image between instances of C1Bitmap.

## C1.UWP.FlexChart

### Bug fixes

- The FlexChart is not clipped in exported image.(TFS-227822)
- The StrokeDashArray is not applied to FlexChart while setting of FunnelType as
  Rectangle and RenderMode as Direct2D.(TFS-227777)

### Improvements

- [C1FlexChart] Add ErrorBar and BoxWhisker series.
- [C1FinancialChart] Add Fibonacci tools.
- [C1FinancialChart] Add Envelops and Bollinger Bands overlay series.
- [C1FinancialChart] Add MACD, Stochastic indicators.

## C1.UWP.FlexGrid

### Breaking changes

- Removed obsolete ShowGroups property.

### Bug fixes

- FlexGrid is distorted when resizing the frozen column while grouped data by C1CollectionView is bounded. (TFS-207850)

## C1.UWP.FlexViewer

### Improvements

- Added the print option that allows to specify the number of copies. (TFS:233490)

## C1.UWP.Gauge

### Bug Fixes:

- [C1Knob] PointerCapFill, PointerCapStrokeThickness proeprties don't work.(TFS-34543)

## C1.UWP.InputPanel

### Improvements

- First Release.

## C1.UWP.RichTextBox

### Bug fixes:

- All pasted text are not removed at once by an Undo (Ctrl+Z ) action.(TFS-229806)

## C1.UWP.Word

### Bug fixes

- Image in the MS Word file is not retained when load to C1WordDocument and save with Docx format. (TFS:204965)
- Text are not fit into field's bound in RTF/Word/Excel exported file when use "TextFitMode". (TFS:191006)
- Forecolor of RTF paragraph is not effected when save the C1WordDocument with RTF format. (TFS:224991)
- An unhandled exception of type 'System.FormatException' occurred in C1.WPF.Word.4.dll. (TFS:233860)

### Improvements

- Changed DOCX format reader for support merged cells of the table.
- Added ForeColor for Word/RTF paragraph object.
- Added support expand (spacing between characters) value for DOCX format.

# Release version 10.0.20163.542 - 01/10/2017

## C1.UWP.Bitmap

### Bug fixes

- C1.UWP.Bitmap assembly was not properly signed. (TFS:233015)

# Release version 10.0.20163.541 - 01/09/2017

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] Height of the bars in BarChart is shortened when it includes a long value for the "BindingX" parameter.(TFS-230947)

# Release version 10.0.20163.540 - 12/27/2016

## C1.UWP.Pdf

### Bug fixes

- Object reference Exception occurs at C1.UWP.Pdf while exporting of RTB document to pdf by using PdfFilter.PrintDocument().(TFS:224999)

# Release version 10.0.20163.539 - 12/23/2016

## C1.UWP.Pdf

### Bug fixes

- [Regression] Not all rotated text are rendered when rotated text are created by using PdfDocument.DrawString() method. (TFS:209554)

# Release version 10.0.20163.537 - 12/15/2016

## C1.UWP.Bitmap

### Bug fixes

- System.ArgumentException is thrown when rotate the JXR file by using TransformOptions. (TFS:227961)

## C1.UWP.FlexReport

### Breaking Changes

- Now non paginated RTF export is used by default, i.e. RtfFilter.Paged is false by default.

## C1.UWP.FlexViewer

### Bug fixes

- A reference to C1FlexChart not added to the project references when adding C1FlexViewer from the toolbox.

# Release version 10.0.20163.536 - 12/12/2016

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexChart] Legend border and border color are shown in svg image. (TFS-222077)
- [C1FlexChart] Background color of FlexChart is lost in exported SVG image.(TFS-222217)
- [C1FlexChart] SelectionChanged event is fired twice at first while selecting any series.(TFS-222394)

## C1.UWP.FlexGrid

### Bug fixes

- The data in the cell is copied to the cell below it when using StartEdit(False) method in the SelectionChanged event and focus to cell is changed using the cursor keys. (TFS-224968)
- Later columns do not come out in visible screen of Win10 Phone device and Mobile Emulator after resizing the columns to very smaller width. (TFS-208242)

### Improvements

- Reset Row/Column size to original value if resizing was cancelled by pressing Escape key. (TFS-222710)

## C1.UWP.FlexReport

### Breaking Changes

- SubreportParameterValue was renamed to ReportParameterValue.
- SubreportParameterValues was renamed to ReportParameterValues.

### Bug fixes

- C1FlexReport.EndPage event not fired for last page of the report. (TFS:227288)

### Improvements

- Added two more variants to define hyperlink in the report (see FieldBase.Hyperlink property):
- ReportLinkTargetScript. Script will be executed when user perform navigation, see "Interactive Report" sample.
- ReportLinkTargetBookmark. Added properties Report and ParameterValues properties
  which allow to create a link to another report or to same report with different parameters.
- Added new FlexChartField report field, supporting the following chart
  types: Column, Bar, Line, Scatter, LineSymbols, Area, Spline,
  SplineSymbols, SplineArea, Bubble, Candlestick, HighLowOpenClose,
  Funnel. The new FlexChartField is supported on all platforms
  (WinForms, WPF, UWP).
  FlexChartField internally uses the FlexChart control, so now
  C1.WPF.Document.4 and C1.WPF.FlexReport.4 assemblies require the
  C1.WPF.FlexChart.4 assembly, UWP assemblies C1.UWP.Document and C1.UWP.FlexReport require
  C1.UWP.FlexChart.
- Now ForcePageBreak specified for FieldBase, Section or SubSection assigned to the
  RenderObject.LayoutBreak this allows to improve exporters.

## C1.UWP.FlexViewer

### Bug fixes

- Sometimes the Ctrl-F keys did not work correctly.

## C1.UWP.TileView

### Bug fixes

- System.ArgumentOutOfRangeException occurs when adding of 8 or above child C1TileViewItem,
  maximizing/minizing 7th and later TileViewItems. (TFS-227274)

# Release version 10.0.20163.535 - 11/28/2016

## C1.UWP

### Bug fixes

- [NumericBox] Application stops executing on typing value in NumericBox. (TFS-17831)

## C1.UWP.Bitmap

### Bug fixes

- System.NotSupportedException occurred while saving bitmap to Jpeg by using SaveAsJpeg() with ImageQuality property. (TFS:222673)

## C1.UWP.DX

### Improvements

- [WPF] Many small improvements to the common structures like Matrix3x2 and others.

## C1.UWP.Excel

### Bug fixes

- First sheet is always selected when setting 'SelectedIndex' value less than 'FirstIndex'
  value. (TFS:19584)
- One of the columns in the second sheet becomes invisible after saving in the different
  path and opening it. (TFS:15297)
- Error 'Invalid Excel OpenXml file' is occurred on opening of an excel file
  contains TabColor and formulae after saving as another one. (TFS:197450)

## C1.UWP.FlexGrid

### Breaking changes

- removed BottomRightCellBackground property. It is not applicable to UWP version. (TFS-108093)

### Bug fixes

- FlexGrid doesn't create autogenerated column for decimal values. (TFS-119735)
- FontFamily property doesn't properly applied at edit mode. (TFS-110141)
- Only 1st column can be resized in touch action.(TFS-208234)

## C1.UWP.FlexReport

### Bug fixes

- Error occurs during rendering if name of field of DataSource equals to VBScript keyword like "To", "While" etc. (TFS:221944)

## C1.UWP.Pdf

### Bug fixes

- Attachment Pdf document is not opened when adding attachment to pdf document by using C1PdfDocument.AddAttachment() method. (TFS:213228)

## C1.UWP.PdfViewer

### Bug Fixes

- Logo image color in original pdf file is not retained when view the pdf file in C1FlexViewer. (TFS-221614)

## C1.UWP.SpellChecker

### Improvements

- Add default dictionary in SpellChecker.(TFS-17900)

# Release version 10.0.20163.534 - 11/14/2016

## C1.UWP.Bitmap

### Improvements

- C1Bitmap added to the suite.

## C1.UWP.Calendar

### Bug fixes

- [MultiWindow]"System.Runtime.InteropServices.COMException: Error HRESULT E_FAIL.." occurs when Calendar contained app is opened as Multi-windows (TFS-216145).

## C1.UWP.Excel

### Bug fixes

- Japanese characters, font styles, watermarks and shapes are not rendered in output
  .xlsx file. (TFS:204191 cases 2 & 5)
- Multiple issues are observed when loading .xlsx file that contains cells with thousand
  separators and 11 decimal values). (TFS:208468 case 1)

## C1.UWP.FlexChart

### Improvements

- [C1FlexChart] Add funnel chart type.

## C1.UWP.FlexViewer

### Breaking changes

- To simplify usage, all commands are defined as instance properties, not static properties.

### Bug fixes

- An error occurred if the type of default value in report parameter does not match the type of allowed values.

### Improvements

- Commands are now available for the C1FlexViewer control, not just C1FlexViewerPane.
- Added new commands for navigation and selection.
- Supported FlowDirection.RightToLeft for C1FlexViewer and C1FlexViewerPane. (TFS:150404)

## C1.UWP.OrgChart

### Bug Fixes

- Fixed the issue that System.Exception occurs when C1OrgChart is opened in
  multiple windows.(TFS-216147)

## C1.UWP.Schedule

### Bug Fixes:

- [MultiWindow]"Failed to connect to index [x] in object" error occurs when Schedule contained app is opened as Multi-windows (Tfs 216146).

## C1.UWP.Tile

### Bug fixes

- "System.Exception: The application called an interface that was marshalled for a different thread.."
  occurs when used C1Tiles in multi-window apps (Tfs 216320).

# Release version 10.0.20163.532 - 10/21/2016

## C1.UWP

### Bug fixes

- [C1NumericBox] Fixed the issue that Application is not responding when pressing key combination with Ctrl/Shift
  in C1Numeric box.(TFS-211564)

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexRadar] Fixed the issue that application is crashed while setting of ChartType
  as LineSymbol and StrokeDashArray property.(TFS-213710)

## C1.UWP.FlexGrid

### Bug fixes

- Window containing flexgrid is only opened once. (TFS-214340)

# Release version 10.0.20163.531 - 10/17/2016

## C1.UWP.FlexChart

### Bug fixes

- [C1Sunburst] Fixed the issue that the default name is "flexPie".(TFS-212469)
- [C1Sunburst] Fixed the issue that ItemSource at runtime is not
  reflected back on the chart.(TFS-211573)

### Improvements

- [C1FlexChart] Export FlexChart as SVG image.

# Release version 10.0.20163.530 - 10/10/2016

## C1.UWP.FlexGrid

### Bug fixes

- Row selection is still remained after changing SelectionMode from ListBox to RowRange. (TFS-40451)

## C1.UWP.FlexReport

### Bug fixes

- In some cases text selected in viewer copied not fully if report contains CheckBoxField. (TFS:211679)

# Release version 10.0.20163.529 - 10/04/2016

## C1.UWP.FlexGrid

### Bug fixes

- System.ArgumentException exception is thrown when a column of the grid is sorted repeatedly. (TFS-209852)
- System.ArgumentOutOfRangeException occurs when dragging the Frozen ColumnHeader to its column area in the grid. (TFS-207839)
- Adorners still shown when changed SelectionMode property from RowRange/CellRange to Row/Cell. (TFS-106875)
- Value of one digit integer columns can not be seen in FlexGrid when it is placed in last index. (TFS-207950)
- Only 1st column can be resized in Touch action. (TFS-208234)

## C1.UWP.FlexReport

### Improvements

- ChartField
- Map and SuperLabel custom fields

# Release version 10.0.20163.528 - 09/26/2016

## C1.UWP.Document

### Improvements:

- Added event:
  public event EventHandler<PrintTaskCompletedEventArgs> PrintTaskCompleted
  Occurs when the print task started with ShowPrintUIAsync() method is finished.

## C1.UWP.FlexChart

### Improvements

- [C1FlexRadar] First release.

## C1.UWP.FlexViewer

### Bug fixes

- Text selection appears and not refreshed in Thumbnail view. (TFS:209282)
- COM Exception is thrown when add C1FlexViewer and C1FlexViewerPane onto the form. (TFS:209488)
- Tool panel header is clipped when the panel is resized to minimum width. (TFS:209436)
- Thumbnails disappeared after opening the Thumbnail view and waiting 5 to 6 minutes. (TFS:209420)

## C1.UWP.Pdf

### Bug fixes

- System.NullReferenceException occurred in C1.UWP.Pdf.dll when creating lines in PdfDocument using PdfDocument.DrawLines() method. (TFS:209579)

## C1.UWP.Schedule

### Bug Fixes:

- Time formats of Schedule are disappeared while switching the tabs of C1TabControl that contains C1Schedule (Tfs 208814).

# Release version 10.0.20163.526 - 09/19/2016

## C1.UWP

### Bug fixes

- [C1TabControl] Fixed the issue that Navigation buttons also changed to
  italic when setting the FontStyle to Italic of the C1TabControl. (TFS-206778)

## C1.UWP.DateTime

### Improvements:

- Added handling of 'F4' key (opens drop-down) (Tfs 208235).

## C1.UWP.FlexChart

### Breaking changes

- Change the namespace of IChartLayer from C1.Xaml.Chart.Interaction to C1.Xaml.Chart.

### Improvements

- [C1FlexChart] Add Waterfall series.
- [C1FlexChart] Add annotations.

## C1.UWP.FlexViewer

### Bug fixes

- A sporadic exception occurred in C1FlexViewer after cancelling the Print dialog on Windows Phone device.
- FlexViewer thrown an exception in a multi-window UWP application while opening the second window. (TFS:208226)

### Improvements

- Added the ability to select text on multiple pages.

## C1.UWP.Pdf

### Bug fixes

- Check boxes interaction can not be performed and radio buttons are disappeared in
  output pdf file from C1Pdf. (TFS:205954)
- Unknown character shown when Japanese character exported to pdf file for C1RichTextBox. (TFS:97308)

### Improvements

- Added support of alternative fonts for Chinese, Korean, Japanese characters.

## C1.UWP.RichTextBox

### Improvements:

- Add AutoCapitalizationMode property to indicate how to handle auto capitalization.(TFS-114613)
  None: Specifies that there is no automatic text capitalization. This is the default type.
  Sentence: Specifies automatic capitalization of the first letter of each sentence.

# Release version 10.0.20162.524 - 08/29/2016

## C1.UWP

### Bug fixes

- [RadialMenu][Win10 Anniversary Edition]Menu icon is lost in the center area of RadialMenu (TFS-204795).
  Using SystemAccentColor in the style setter for AccentBrush property replaced by the SystemControlHighlightAccentBrush.

## C1.UWP.Calendar

### Bug fixes

- [Win10 Anniversary Edition]Today color is lost (TFS-204795).
  Using SystemAccentColor in the style setter for TodayBrush property replaced by the SystemControlHighlightAccentBrush.

## C1.UWP.FlexViewer

### Bug fixes

- An unhandled win32 exception is thrown when export some pdf files to image type files. (TFS:204810)

# Release version 10.0.20162.523 - 08/23/2016

## C1.UWP.Document

### Breaking Changes:

- HtmlFilterBase: default value of SingleFile property changed to true.

## C1.UWP.FlexReport

### Bug fixes

- Exception is thrown when cancelling the exporting process from C1FlexViewer. (TFS:203812)

## C1.UWP.Schedule

### Bug Fixes:

- Next index months can not be selected in the calendar dropdown of C1Scheduler (Tfs 204398).

# Release version 10.0.20162.522 - 08/22/2016

## C1.UWP.FlexChart

### Bug fixes

- [C1FlexPie] Fixed the issue that C1FlexPie is not updated when
  change the corresponding value (TFS-202556).

## C1.UWP.FlexReport

### Bug fixes

- Exception is thrown when cancelling the exporting process from C1FlexViewer. (TFS:203812)

## C1.UWP.FlexViewer

### Improvements

- Tooltips and all items in C1FlexViewer were not localized to Japanese. (TFS:203599)

## C1.UWP.Pdf

### Improvements

- Added PdfAcroform sample (for demo of Acroform fields) for C# and VB.

# Release version 10.0.20162.521 - 08/15/2016

## C1.UWP.Document

### Bug fixes

- Font color of text is changed to white in exported RTF when backcolor of TextField/ParagraphField are set to Purple. (TFS:193644)

## C1.UWP.FlexReport

### Bug fixes

- Fields with FieldBase.Anchor != AnchorEnum.Top split incorrectly between pages in some cases. (TFS:202376)
- bool C1FlexReport.BehaviorOptions.EnableAggregatesOnReportFields was added to improve
  compatibility with C1Report. Set it to true if in your report aggregate functions use report fields. (TFS:203132)

### Improvements

- Now text can be specified for report's watermark or overlay. Following properties were added
  to the Watermark class describing C1FlexReport.Watermark and C1FlexReport.Overlay:
  -- public string Text { get; set; }
  -- public WritingMode WritingMode { get; set; }
  -- public FieldAlignEnum Align { get; set; }
  -- public Color ForeColor { get; set; }
  -- public float TextAngle { get; set; }
  -- public bool WordWrap { get; set; }
  -- public FontHolder Font { get; set; }
  -- public double LineSpacing { get; set; }
  -- public TextFitMode TextFitMode { get; set; }
  -- public double Opacity { get; set; }
  If both Watermark.Picture and Watermark.Text are specified then watermark/overlay will be rendered as image.

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that C1RichTextBox loose color and table formatting while copying content.(TFS-202426)
- Fixed the issue that focus can not be placed outside of the table and text can not be input anymore in C1RichTextBox after
  paste the table from MSWord.(TFS-200826)

# Release version 10.0.20162.520 - 08/08/2016

## C1.UWP.BarCode

### Bug fixes

- Fixed the issue that EncodingException.Message always returns "Invalide barcode data"
  after receiving an exception in encoding the barcode.(TFS-201539)

## C1.UWP.Excel

### Bug fixes

- 'System.ArgumentException" occur in C1.WPF.Excel.4.dll while loading of .xlsx file
  contains Profit-And-Loss calculation and formula. (TFS:200261)
- #VALUE! is shown in the cell with .xls excel file after loading and saving an excel
  file which has '=SUM((B1,B2))' formula with C1Excel. (TFS:195419)
- When a Excel file that has RTF texts including line break is loaded, an unnecessary
  blank is inserted between the 2 byte characters at the time of an RTF translation
  (Regression from TFS:191100). (TFS:198035)

### Improvements

- At UseTempStorage for UWP used ApplicationData.Current.TemporaryFolder.

## C1.UWP.FlexChart

### Improvements

- [C1Sunburst] First release.

## C1.UWP.FlexGrid

### Bug fixes

- Disable sorting for autogenerated column if column data type doesn't implement IComparable interface. (TFS-201006)
- Fixed the issue that there is no mark in frozen column header when tapping on frozen column. (TFS-197234)

## C1.UWP.FlexViewer

### Bug fixes

- The hamburger icon of C1FlexViewer is overlapped with text "empty" in Design View. (TFS:200829)
- Text appears rotated when load the Acroform pdf file into the C1FlexViewer. (TFS:200939)
- Page is cutoff when load Acroform pdf file and view it in FacingPages mode. (TFS:201041)
- Unhandled exception is thrown when navigate to the some pages in C1FlexViewer. (TFS:201004)

### Improvements

- Supported page rotation by 90/180/270 degrees, added RotateView property to C1FlexViewer.

## C1.UWP.Pdf

### Improvements

- Added support PDF/A compliance for PDF annotations. PDF/A bug fixing.

## C1.UWP.Word

### Bug fixes

- Text's alignment of original document is not retained in new document. (TFS:191068)
- Backfilling color changes in output .rtf and not effected in output .docx file
  when load/save the MS Word Document to C1Word. (TFS:196282)
- Font Size of MS word file is not retained when load and save in C1WordDocument. (TFS:193081)
- System.FormatException is thrown when load the docx file contained bookmark and save
  it in another document. (TFS:192836)
- PageBreak from MS word does not effect in C1WordDocument when load MS word file and
  save it in C1Wordocument. (TFS:193054)
- Position of Footer text are different in RTF and Docx Files. (TFS:196953)
- Text behind the tab character "\t" are disappeared in output RTF file. (TFS:197388)
- Background filling color of main section in the C1WordDocument is not effective in
  output RTF and DOCX files. (TFS:153736)
- WidthPercent of Table row is not effected in word doucument with Docx format. (TFS:153145)
- Font color of "RTF Field" is not effected in exported Docx and RTF files (TFS:201537)

# Release version 10.0.20162.519 - 07/21/2016

## C1.UWP

### Bug fixes

- [C1CollectionView] Fixed wrong thread exception when use C1CollectionView
  from multiple UI threads (http://our.componentone.com/groups/topic/c1collectionview-multiple-ui-threads/#post-680904)

## C1.UWP.Excel

### Bug fixes

- Error occurs in output file while loading and saving of the border style containing
  .xls/.xlxs to C1Excel. (TFS:191302)
- When the report is exported to Excel file with .xls format, background color in
  some field may change. (TFS:195006)
- Comment of cell in result excel file is not properly shown in C1Excel when loading
  and saving to C1Excel. (TFS:191100)
- Request to provide bitmap support in SL Excel. (TFS:19275)

### Improvements

- Used a reference to C1.UWP.Zip library instead of shared C1Zip code.

## C1.UWP.Pdf

### Improvements

- Used a reference to C1.UWP.Zip library instead of shared C1Zip code.
- Reset file lenght at saving.
- Fixed support PDF Acroforms for XAML versions.

# Release version 10.0.20162.518 - 07/18/2016

## C1.UWP.FlexGrid

### Bug fixes

- Column header's background color disappears while selecting any cell in C1FlexGrid. (TFS-199595)

# Release version 10.0.20162.517 - 07/04/2016

## C1.UWP.Calendar

### Bug fixes

- Fixed UWP design-time behavior (Tfs 197657).

## C1.UWP.DateTime

### Improvements:

- Removed angle brackets from default watermak in DatePicker control.

## C1.UWP.FlexViewer

### Breaking changes

- The PrepareToolsMenu event of C1FlexViewer renamed to PrepareToolMenu.
- CustomToolEventArgs.Handled property renamed to NavigatedTo.

### Bug fixes

- Content in FlexViewer cannot be copied with Ctrl+C shortcut. (TFS:196341)

# Release version 10.0.20162.516 - 06/27/2016

## C1.UWP.FlexGrid

### Bug fixes

- Fixed the issue that System.ArgumentOutOfRangeException occurs "mscorlib"
  while Tapping on ForzenColumn header.(TFS-195395)

## C1.UWP.FlexViewer

### Bug fixes

- Exception was thrown when set "Non-Print Layout", "NonContinous" in Eight Pages view of Wide Report. (TFS:195066)
- Selection is not moved to the related thumbnail while changing the current page number in FlexViewer. (TFS:195245)
- Clicking an outline item didn't scroll report to the target position on a Windows Phone.
- Text selection grips shown far away from selection start/end when using touch to select the rotated text. (similar to TFS:195761)

### Improvements

- Added the NavigateToCustomTool event that occurs when the user clicks the custom tool menu item.
- Added the PrepareToolsMenu event that occurs after adding the default items to the Tools menu.
- Added the ToolMenuItems property to C1FlexViewer. It allows to customize the Tools menu.

### Other changes

- The PageFillBrush property of C1FlexViewer and C1FlexViewerPane has been renamed to PageBackground.

# Release version 10.0.20162.515 - 06/22/2016

## C1.UWP.FlexGrid

### Bug fixes

- Fixed the issue that ArgumentOutOfRangeException occurs in mscorlib
  while setting of FrozenColumn property.(TFS-195012)

# Release version 10.0.20162.514 - 06/21/2016

## C1.UWP.FlexGrid

### Bug fixes

- Fixed the issue that selecting a cell and dragging the selected cell
  containing column, selection does not come a long with moved column.(TFS-191988)
- Application crashes while selecting a row of C1FlexGrid which is running in "Release" mode.(TFS-194384)
  Exception is fixed. Note, for proper working with .Net Native compilation, include next line into Default.rd.xml file of your application:
  <Namespace Name="Windows.UI.Xaml.Controls" Serialize="PublicAndInternal" />
  https://social.msdn.microsoft.com/Forums/sqlserver/en-US/3e628f21-04b5-418e-a609-8d804c106889/problem-with-type-getproperties?forum=dotnetnative
- Fixed the issue that System.Collections.Generic.KeyNotForundException occurs
  in "mscorlib" when tapping on "Select All" area of FlexGrid in touch machine.(TFS-192178)
- Fixed the issue that Frozen Columns can not be drag and drop .(TFS-192542)
- Fixed the issue that "ArgumentOutOfRangeException" occurs in "mscorlib"
  when applying of AllowMerging Enums to the FlexGrid where FrozenColumns property
  has already been set.(TFS-191991)

### Improvements

- Add FrozenColumns and FrozenRows property to get or set a value that determines
  whether columns or rows should be frozen when scrolling.(TFS-144316)

## C1.UWP.FlexViewer

### Bug fixes

- Default item is not selected in View dropdown of C1FlexViwer when remove the checkmark ofcustomized item. (TFS:194355)
- First page disappeared from FlexViewer when switching to "Facing Pages" in non-continuous mode. (TFS:194393)

### Improvements

- Added the WideLayout property specifying whether a multi-column layout is applied to wide reports by default.

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that System.ArgumentException is occurred when pressing
  the 'Ctrl+Z' key in C1RichTextBox after deleting the content.(TFS-192381)

# Release version 10.0.20162.512 - 06/08/2016

## C1.UWP.FlexChart

### Improvements

- [C1FinancialChart] First release.

# Release version 10.0.20162.511 - 06/06/2016

## C1.UWP

### Breaking changes

- Changed licensing. Removed old design-time licensing model.
  Since 2016 v2 release every application must set C1.UWP.LicenseManager.Key property to valid evaluation or full license key.

## C1.UWP.FlexGrid

### Bug fixes

- Fixed the issue that selection is not correct after move columns to another position.(TFS-153569)

## C1.UWP.FlexReport

### Improvements:

- Added methods:
  public new async Task ShowPrintUIAsync(C1PrintOptions options)
  public async Task ShowPrintUIAsync()
  Both can be used to print generated report, Printing page of the FlexReportSamples sample demonstrates the using of these methods.
- Added properties:
  float TextFieldBase.TextAngle { get; set; }
  float Field.TextAngle { get; set; }
  Gets or sets the angle of text rotation within the field.
  double TextFieldBase.LineSpacing { get; set; }
  double Field.LineSpacing { get; set; }
  Gets or sets the line spacing between text lines in the field, in percent. The default is 100 which corresponds to normal line spacing.
  TextFitMode TextFieldBase.TextFitMode { get; set; }
  Gets or sets a value indicating how the text is fit into field's bounds.
- Behavior change: previously, if the type of a field could not be
  resolved while loading a report, an exception occurred. Now instead of
  the exception a text field is created, with the following text:
  Unknown field type [XXX]. This field type may not be supported in the current edition of FlexReport.

## C1.UWP.FlexViewer

### Bug fixes

- Checkmarks are not shown beside some items in the View dropdown of FlexViewer. (TFS:189652)
- Addressed multiple issues with zooming to page width and switching view modes.

### Improvements

- Added text search panel.
- Added the PageBorderBrush, PageAreaBackground, and PageFillBrush properties to C1FlexViewer.
- Supported page thumbnails in C1FlexViewer.

## C1.UWP.Imaging

### Improvements

- Added Bmp Codec for support of BMP format. Supported only reading/loading of files. Writing/saving not supported now.

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that border of the cell comes along with image as the border
  of image while dragging a image in table to another cell.(TFS-153416)

## C1.UWP.Schedule

### Bug Fixes:

- Fixed memory leak (Tfs 190302).

# Release version 10.0.20162.509 - 05/16/2016

## C1.UWP

### Improvements

- [C1RangeSlider] Add ScrollBehavior property.

## C1.UWP.FlexChart

### Improvements

- Change beta license to normal license.

## C1.UWP.FlexGrid

### Bug fixes

- Fixed the issue that private properties are also rendered.(TFS-153844)

### Improvements

- Add IsDeferredScrollingEnabled property to get or set a value that determines
  whether scrolling should be deferred until the user releases the scrollbar thumb.(TFS-144316)

## C1.UWP.FlexViewer

### Bug fixes

- Page Number is shown as 0 when load the report contained only one page to FlexViewer. (TFS:152758)
- Unhandled exception is thrown when change the Page size to "Default". (TFS:152956)

### Improvements

- Supported non-continuous mode in C1FlexViewerPane.

## C1.UWP.PdfViewer

### Bug Fixes

- Fixed the issue that application crashes while loads a pdf document. (TFS-152429)

## C1.UWP.RichTextBox

### Improvements:

- Add support for moving(drag/drop) pictures within the document.(TFS-153359)

# Release version 10.0.20161.508 - 04/27/2016

## C1.UWP.FlexViewer

### Bug fixes

- An exception was thrown when closing a report which is in busy state.
- An exception occurred sometimes when switching from one report to another.
- C1FlexViewer thrown an exception on the designer surface.
- Mouse cursor was changed to IBeam after performing layout even if the viewer doesn't contain the mouse pointer.
- The "Open the document after export" checkbox is now hidden for Windows Phone.

# Release version 10.0.20161.507 - 04/23/2016

## C1.UWP.FlexChart

### Bug fixes

- Fixed the problem with rendering selected series for area chart (TFS 150626).
- The axis displayed correctly after setting axis origin (TFS 150968).
- Series with bubble chart type are rendered correctly (TFS 150995).
- Cancel property works properly for SymbolRendering event in financial charts (TFS 151123).
- Fixed the problem with exception in area spline charts (TFS 151718).

## C1.UWP.FlexViewer

### Improvements

- Added C1FlexViewer control (beta version).

## C1.UWP.Word

### Bug fixes

- There is no footer visible in the Word document created using C1Word when it is saved in Docx format. (TFS:150574)

### Improvements

- Add support of table cell pading for Open XML format (DOCX).

# Release version 10.0.20161.506 - 04/01/2016

## C1.UWP.FlexViewer

### Bug fixes

- Text selection with touch didn't work correctly for the second and subsequent pages with display modes other than 96 DPI.
- Customized ZoomFactor value was not applied to C1FlexViewerPane. (TFS:149472)

## C1.UWP.RichTextBox

### Improvements:

- AutoFormatHyperlinks is used to indicate whether Url strings would be converted
  to hyperlink when the user presses the ENTER or SPACE key.(TFS-146369)

## C1.UWP.Word

### Bug fixes

- ForeFilling color of table in the C1Word Document is not effective in output RTF and DOCX files. (TFS:144710)
- Line break key 'Ctrl+Enter' in the Text Field , RTF Field and Paragraph Field are not effected in
  Word export. (TFS:139058)

### Improvements

- Impoved support of Word/RTF borders (for all RtfBorderObject heirs). Added RtfTableBorderObject
  for all table objects (RtfTable, RtfRow and RtfCell).

# Release version 10.0.20161.505 - 03/18/2016

## C1.UWP.FlexViewer

### Bug fixes

- An exception was thrown in Designer View after adding C1FlexViewerPane control. (TFS:149015)

### Improvements

- Supported links, text selection, improved the object model.

# Release version 10.0.20161.504 - 03/14/2016

## C1.UWP.FlexViewer

### Bug fixes

- Unhandled exception was thrown when the Visibility property is set to "Collapsed". (TFS:147653)

## C1.UWP.Maps

### Bug fixes:

- Fixed the issue that C1Maps does not move to any direction
  by pressing arrow keys.(TFS-67665)

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that text alignment of cell content is not retained as in
  original while the nested table is copied and pasted.(TFS-144929)

# Release version 10.0.20161.503 - 03/01/2016

## C1.UWP.FlexViewer

### Improvements

- First release.

# Release version 10.0.20161.502 - 02/23/2016

## C1.UWP

### Improvements

- added support for MenuFlyoutItems in C1CommandExtensions.

## C1.UWP.Excel

### Bug fixes

- Excel file does not exported correctly while exporting the styles and merging the
  cells of C1Excel. (TFS:144689)

## C1.UWP.Gauge

### Bug Fixes:

- Request to set default value for "FontFamily" in C1Gauge.Decorators.C1GaugeLabel property. (TFS-32018)

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that On-Screen keyboard always opens in upper case on
  Win10 Tablet.(TFS-143565)

## C1.UWP.TileView

### Bug fixes

- Remove "ButtonBackground" and "ButtonForeground" properties
  since there is no button in C1TileView. (TFS-33882)

## C1.UWP.Word

### Bug fixes

- Backfilling color of table in the C1Word Document is not effective in output RTF
  file. (TFS:144707)

# Release version 10.0.20161.501 - 02/03/2016

## C1.UWP.Excel

### Bug fixes

- "Invalid Excel OpenXml file (*.xlsx)" exception is thrown while Importing
  an Excel(.xlsx) file generated using Altova Mapforce or Telerik
  SpreadSheetProcessing for Wpf with C1Excel. (TFS:142312)

## C1.UWP.Pdf

### Bug Fixes

- Other system font do not get applied to C1PDF. (TFS:143375)

## C1.UWP.Word

### Improvements

- First release.

# Release version 10.0.20161.500 - 01/25/2016

## C1.UWP.FlexChart

### Improvements

- First release.

## C1.UWP.FlexReport

### Improvements

- First release.

# Release version 10.0.20161.499 - 01/18/2016

## C1.UWP

### Bug fixes

- [C1TreeView] Fixed the issue that LineStroke and MouseOverBrush properties
  are not affected.(TFS-33794)

## C1.UWP.Excel

### Bug fixes

- At times, position of a string is changed to BottomAligned in the output. (TFS:139667)

## C1.UWP.Gauge

### Bug Fixes:

- Fixed the issue that PointerStroke and PointerStrokeThickness are not effected in C1Knob.(TFS-41841)

## C1.UWP.Pdf

### Bug Fixes

- Color for pie chart is not exported correctly to pdf file. (TFS:137852)
- "NullReferenceException" has occurred when saving the pdf file that has attachment. (TFS:132231)

### Improvements

- Common code with C1Pdf for WinForms and many changed for it.
- Added support embedded fonts (TrueType fonts, FontType property).
- Added support of PDF/A format (ConformanceLevel property).
- Changes for support bookmarks and links for FlexReport. Added new AddBookmark method.

## C1.UWP.PdfViewer

### Bug Fixes

- Fixed the issue that error image got displayed instead of smiles while
  loading a pdf file in C1PdfViewer(TFS-137440)

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed could not add space before table.(TFS-33428)

# Release version 10.0.20153.496 - 12/23/2015

## C1.UWP

### Bug fixes

- [C1RadialMenu] C1RadialMenu freezes whole screen on Windows 10 (TFS-137618).

# Release version 10.0.20153.493 - 11/30/2015

## C1.UWP.TileView

### Bug fixes

- Fixed the issue that NullReferenceException is thrown
  if HeaderAlignment property of C1TileViewItem are set at run time.(TFS-42944)

# Release version 10.0.20153.492 - 11/23/2015

## C1.UWP

### Improvements

- [C1RadialMenu] Add CollapseOnClick property for
  C1RadialMenuItem to indicate if the menu will auto collapse when the user clicks on
  item which has no child items.

## C1.UWP.BarCode

### Improvements

- Add SaveAsync(Stream stream, ImageFormat imgFormat) to save C1BarCode
  as Image.(TFS-119864)

## C1.UWP.Excel

### Improvements

- Added new C1XLBook.ListSeparator property for using in methods C1XLBook.Load
  (for .cvs files), XLSheet.LoadCsv and XLSheet.SaveCsv.

## C1.UWP.Maps

### Bug fixes:

- Fixed the issue that C1VectorPolyline rendered behind the
  coordinate point in C1Maps.(TFS-137617)

## C1.UWP.RichTextBox

### Bug fixes:

- Fixed the issue that content will go to next line when press
  space key in C1RichTextBox.(TFS-136732)

## C1.UWP.Schedule

### Improvements:

- Scheduler control templates reviewed for better performance.
  Default control templates don't use C1Scheduler.VisualIntervalTemplate property.
- C1SchedulerNavigator control has been moved out of the looping area.
  Scheduler navigation buttons moved from the C1Scheduler template to the
  C1SchedulerNavigator control.
  That allows to use empty space near the C1SchedulerNavigator control to
  show custom navigation UI (see our updated samples).
- TimeRuler reviewed for performance. It is moved out of looping area
  in the default C1Scheduler control template and doesn't need setting
  ItemsSource from xaml any more.

# Release version 10.0.20153.490 - 11/14/2015

## C1.UWP.Excel

### Bug fixes

- Image and CheckBox is not retained when the Excel file containing
  check box and image is saved. (TFS:136880)
- C1Excel incorrect loaded/saved hyperlink ("Cannot open the specified file.")
  (TFS:136722)

## C1.UWP.Tile

### Improvements

- Removed C1FlipTile flickering at rotation.

# Release version 10.0.20153.489 - 10/31/2015

## C1.UWP.Excel

### Bug fixes

- Cell range is NOT selected when cell range with Frozen row/col is
  selected in C1Excel book. Regression issue. (TFS:30427)

# Release version 10.0.20153.487 - 10/27/2015

## C1.UWP

### Breaking changes

- [C1ListViewer] BringIndexIntoView method second parameter "subOffset" default value
  is set to null, and second parameter "subOffset" is nullable now. The same in its'
  derived controls C1ListBox/C1TileListBox.

## C1.UWP.Excel

### Bug fixes

- NullReferenceException is thrown when loading an excle file
  which contains macro with .xlsx/.xls format. (TFS:135360)

## C1.UWP.PdfViewer

### Bug Fixes:

- Fixed the issue that watermark image of pdf document is replaced with red cross
  mark while loading in C1PdfViewer.(TFS-129639)
- Fixed the issue that more than one page is moved while clicking the Next Page button
  of C1PdfViewerToolbar.(TFS-132707)
- Fixed the issue that System.NullReferenceException is thrown while loading a pdf
  document in C1PdfViewer.(TFS-135478)

# Release version 10.0.20153.486 - 10/21/2015

## C1.UWP.Schedule

### Bug Fixes:

- Fixed issues with Calendar drop-down (Tfs 131695).

# Release version 10.0.20153.482 - 09/18/2015

## C1.UWP

### Improvements

- First Release.

## C1.UWP.Automation

### Improvements

- First Release.

## C1.UWP.BarCode

### Improvements

- First Release.

## C1.UWP.Calendar

### Improvements

- First Release.

## C1.UWP.DateTime

### Improvements

- First Release.

## C1.UWP.Excel

### Improvements

- First Release.

## C1.UWP.Extended

### Improvements

- First Release.

## C1.UWP.FlexGrid

### Improvements

- First Release.

## C1.UWP.Gauge

### Improvements

- First Release.

## C1.UWP.Imaging

### Improvements

- First Release.

## C1.UWP.Maps

### Improvements

- First Release.

## C1.UWP.OrgChart

### Improvements

- First Release.

## C1.UWP.Pdf

### Improvements

- First Release.

## C1.UWP.PdfViewer

### Improvements

- First Release.

## C1.UWP.RichTextBox

### Improvements:

- First Release.

## C1.UWP.RichTextBox.PdfFilter

### Improvements

- First Release.

## C1.UWP.Schedule

### Improvements

- First Release.

## C1.UWP.Sparkline

### Improvements

- First Release.

## C1.UWP.SpellChecker

### Improvements

- First Release.

## C1.UWP.Tile

### Improvements

- First Release.

## C1.UWP.TileView

### Improvements

- First Release.

## C1.UWP.Zip

### Improvements

- First Release.

## C1.UWP.RichTextBox.AppBar

### Improvements

- First Release.

## C1.UWP.RichTextBox.Menu

### Improvements:

- First Release.